/*Construction of data set 
IntensiteGaz_MEF
EtudefreqGaz_MEF
used for basic statistics*/
/*First, restrict the data set to our sample; for that use Param_var_mc_duration_sp or _g containing
 gas stations for which we have paramter estimates in our baseline model
Second,correct for beta differences
compute durations*/

/*Population d'tude*/
data EtudeGaz;
set petrole1.Param_var_mc_duration_g;
keep beta idpv;
if not(beta=.);
run;

proc means data=EtudeGaz; var beta; run;
proc sort data=EtudeGaz; by beta; run;

data EtudeSP;
set petrole1.Param_var_mc_duration_sp;
keep beta idpv;
if not(beta=.);
run;

proc means data=EtudeSP; var beta; run;
proc sort data=EtudeSP; by beta; run;

/*Appariement avec les bases d'intrt*/

/*Frquence*/
/*Gazole*/
/*Suppression des valeurs non-pertinentes*/
data Gazolettc;
set petrole2.Gazolettc;
if not(CG=1);
run;
proc sort data=Gazolettc; by idpdv date; run;
/*Frquence et intensit*/
data etudeFreqGaz;
set Gazolettc;

prixTTC1=lag(prixTTC);
prixTTC2=lag2(prixTTC);
prixHT1=lag(prixHT);
prixHT2=lag2(prixHT);
Date1=lag(Date);
Date2=lag2(Date);
Idpdv1=lag(idpdv);
Idpdv2=lag2(idpdv);

if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)>0 then evol_MEF="1";
else if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)<0 then evol_MEF="1";
else if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)=0 then evol_MEF="0";
else if NumJ=1 then evol_MEF="N";
else if NumJ in (2,3,4,5,6) and Idpdv1=idpdv and Date1=date-1 then evol_MEF=evol;
else if NumJ in (2,3,4,5,6) then evol_MEF="N";
else if NumJ=7 then evol_MEF="N";

if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)>0 then evolDetail_MEF="+";
else if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)<0 then evolDetail_MEF="-";
else if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)=0 then evolDetail_MEF="0";
else if NumJ=1 then evolDetail_MEF="N";
else if NumJ in (2,3,4,5,6) and Idpdv1=idpdv and Date1=date-1 then evolDetail_MEF=evolDetail;
else if NumJ in (2,3,4,5,6) then evolDetail_MEF="N";
else if NumJ=7 then evolDetail_MEF="N";

length DprixTTC_MEF	5.;
format DprixTTC_MEF 6.2;
informat DprixTTC_MEF 6.2;

if NumJ=1 and Idpdv2=idpdv and Date2=date-2 then DprixTTC_MEF=round(((prixTTC-prixTTC2)/prixTTC2)*100,0.01);
else if NumJ=1 then DprixTTC_MEF=.;
else if NumJ in (2,3,4,5,6) and Idpdv1=idpdv and Date1=date-1 then DprixTTC_MEF=round(((prixTTC-prixTTC1)/prixTTC1)*100,0.01);
else if NumJ in (2,3,4,5,6) then DprixTTC_MEF=.;
else if NumJ=7 then DprixTTC_MEF=.; 

length DprixHT_MEF	5.;
format DprixHT_MEF 6.2;
informat DprixHT_MEF 6.2;

if NumJ=1 and Idpdv2=idpdv and Date2=date-2 then DprixHT_MEF=round(((prixHT-prixHT2)/prixHT2)*100,0.01);
else if NumJ=1 then DprixHT_MEF=.;
else if NumJ in (2,3,4,5,6) and Idpdv1=idpdv and Date1=date-1 then DprixHT_MEF=round(((prixHT-prixHT1)/prixHT1)*100,0.01);
else if NumJ in (2,3,4,5,6) then DprixHT_MEF=.;
else if NumJ=7 then DprixHT_MEF=.; 

keep idpdv Date prixTTC prixHT evol_MEF evolDetail_MEF DprixTTC_MEF DprixHT_MEF N00Marque NumJ CD ;
run;
data etudeFreqGaz;
set etudeFreqGaz;
idpv=idpdv+0;
if not(NumJ=7);
run;
/*Appriement avec les stations d'intrt*/
proc sort data=etudeFreqGaz; by idpv; run;
proc sort data=EtudeGaz; by idpv; run;
data etudeFreqGaz_MEF;
merge etudeFreqGaz EtudeGaz (in=a);
by idpv; if a;
run;

/*SP 95*/
/*Suppression des valeurs non-pertinentes*/
data sp95;
set petrole2.Sp95ttc;
if not(CG=1);
run;
proc sort data=sp95; by idpdv date; run;
/*Frquence et intensit*/
data etudeFreqSP95;
set sp95;

prixTTC1=lag(prixTTC);
prixTTC2=lag2(prixTTC);
prixHT1=lag(prixHT);
prixHT2=lag2(prixHT);
Date1=lag(Date);
Date2=lag2(Date);
Idpdv1=lag(idpdv);
Idpdv2=lag2(idpdv);

if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)>0 then evol_MEF="1";
else if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)<0 then evol_MEF="1";
else if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)=0 then evol_MEF="0";
else if NumJ=1 then evol_MEF="N";
else if NumJ in (2,3,4,5,6) and Idpdv1=idpdv and Date1=date-1 then evol_MEF=evol;
else if NumJ in (2,3,4,5,6) then evol_MEF="N";
else if NumJ=7 then evol_MEF="N";

if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)>0 then evolDetail_MEF="+";
else if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)<0 then evolDetail_MEF="-";
else if NumJ=1 and Idpdv2=idpdv and Date2=date-2 and (prixTTC-prixTTC2)=0 then evolDetail_MEF="0";
else if NumJ=1 then evolDetail_MEF="N";
else if NumJ in (2,3,4,5,6) and Idpdv1=idpdv and Date1=date-1 then evolDetail_MEF=evolDetail;
else if NumJ in (2,3,4,5,6) then evolDetail_MEF="N";
else if NumJ=7 then evolDetail_MEF="N";

length DprixTTC_MEF	5.;
format DprixTTC_MEF 6.2;
informat DprixTTC_MEF 6.2;

if NumJ=1 and Idpdv2=idpdv and Date2=date-2 then DprixTTC_MEF=round(((prixTTC-prixTTC2)/prixTTC2)*100,0.01);
else if NumJ=1 then DprixTTC_MEF=.;
else if NumJ in (2,3,4,5,6) and Idpdv1=idpdv and Date1=date-1 then DprixTTC_MEF=round(((prixTTC-prixTTC1)/prixTTC1)*100,0.01);
else if NumJ in (2,3,4,5,6) then DprixTTC_MEF=.;
else if NumJ=7 then DprixTTC_MEF=.; 

length DprixHT_MEF	5.;
format DprixHT_MEF 6.2;
informat DprixHT_MEF 6.2;

if NumJ=1 and Idpdv2=idpdv and Date2=date-2 then DprixHT_MEF=round(((prixHT-prixHT2)/prixHT2)*100,0.01);
else if NumJ=1 then DprixHT_MEF=.;
else if NumJ in (2,3,4,5,6) and Idpdv1=idpdv and Date1=date-1 then DprixHT_MEF=round(((prixHT-prixHT1)/prixHT1)*100,0.01);
else if NumJ in (2,3,4,5,6) then DprixHT_MEF=.;
else if NumJ=7 then DprixHT_MEF=.; 

keep idpdv Date prixTTC prixHT evol_MEF evolDetail_MEF DprixTTC_MEF DprixHT_MEF N00Marque NumJ CD ;
run;
data etudeFreqSP95;
set etudeFreqSP95;
if not(NumJ=7);
idpv=idpdv+0;
run;
/*Appriement avec les stations d'intrt*/
proc sort data=etudeFreqSP95; by idpv; run;
proc sort data=EtudeSP; by idpv; run;
data etudeFreqSP95_MEF;
merge etudeFreqSP95 EtudeSP (in=a);
by idpv; if a;
run;

/*Sauvegarde*/
data petrole1.etudeFreqGaz_MEF;
set etudeFreqGaz_MEF;
run;
data petrole1.etudeFreqSP95_MEF;
set etudeFreqSP95_MEF;
run;

data petrole1.IntensiteGaz_MEF;
set petrole1.etudeFreqGaz_MEF;

if DprixHT_MEF>0 or DprixHT_MEF<0;

length DprixTTC_beta_MEF 5.;
format DprixTTC_beta_MEF 6.2;
informat DprixTTC_beta_MEF 6.2;

DprixTTC_beta_MEF=DprixTTC_MEF/beta;

length DprixHT_beta_MEF	5.;
format DprixHT_beta_MEF 6.2;
informat DprixHT_beta_MEF 6.2;

DprixHT_beta_MEF=DprixHT_MEF/beta;

keep idpdv date numj n00marque evolDetail_MEF DprixHT_MEF DprixHT_beta_MEF DprixTTC_MEF DprixTTC_beta_MEF;
run;

data petrole1.IntensiteSP95_MEF;
set petrole1.etudeFreqSP95_MEF;

if DprixHT_MEF>0 or DprixHT_MEF<0;

length DprixTTC_beta_MEF 5.;
format DprixTTC_beta_MEF 6.2;
informat DprixTTC_beta_MEF 6.2;

DprixTTC_beta_MEF=DprixTTC_MEF/beta;

length DprixHT_beta_MEF	5.;
format DprixHT_beta_MEF 6.2;
informat DprixHT_beta_MEF 6.2;

DprixHT_beta_MEF=DprixHT_MEF/beta;

keep idpdv date numj n00marque evolDetail_MEF DprixHT_MEF DprixHT_beta_MEF DprixTTC_MEF DprixTTC_beta_MEF;
run;

data petrole1.etudeFreqGaz_MEF;
set petrole1.etudeFreqGaz_MEF;
drop idpv DprixHT_MEF DprixTTC_MEF beta;
run;
data petrole1.etudeFreqSP95_MEF;
set etudeFreqSP95_MEF;
drop idpv DprixHT_MEF DprixTTC_MEF beta;
run;


/*Dure*/
/*Gazole*/
data DureeGaz;
set petrole1.Etudefreqgaz_mef;
run;
proc sort data=DureeGaz; by idpdv date; run;
data DureeGaz;
set DureeGaz;
lagIdpdv=lag(idpdv);
lagPrixTTC=lag(prixTTC); 
if lagIdpdv ne idpdv then lagPrixTTC=.;
run;
data DureeGaz;
set DureeGaz;
chg=0;
if prixTTC ne lagPrixTTC then chg=1;
if lagPrixTTC=. then chg=.;
run;
data DureeGaz;
set DureeGaz;
by idpdv;
if first.idpdv then duree=1;
retain;
if chg=0 then duree=duree+1;
retain;
if chg=1 then duree=1;
retain;
run;
data DureeGaz;
set DureeGaz;
LagDuree=lag(Duree);
LagDate=lag(Date);
run;
data DureeGaz_MEF;
set DureeGaz;
if (chg=1 and NumJ=1 and LagDate=Date-2) 
or (chg=1 and NumJ in (2,3,4,5,6) and LagDate=Date-1);
rename Date=DateCgt 
NumJ=NumJLast;
keep idpdv Date LagDuree NumJ N00marque PrixTTC PrixHT;
run;
data DureeGaz_MEF;
set DureeGaz_MEF;
rename LagDuree=Duree;
run;
data petrole1.DureeGaz_MEF;
set DureeGaz_MEF;
Int=NumJLast-(Duree-6*int(Duree/6));
if NumJLast-(Duree-6*int(Duree/6))>0 then NumJ=NumJLast-(Duree-6*int(Duree/6));
else NumJ=NumJLast+6-(Duree-6*int(Duree/6));
drop Int;
run;

/*SP95*/
data DureeSP95;
set petrole1.EtudefreqSP95_mef;
run;
proc sort data=DureeSP95; by idpdv date; run;
data DureeSP95;
set DureeSP95;
lagIdpdv=lag(idpdv);
lagPrixTTC=lag(prixTTC); 
if lagIdpdv ne idpdv then lagPrixTTC=.;
run;
data DureeSP95;
set DureeSP95;
chg=0;
if prixTTC ne lagPrixTTC then chg=1;
if lagPrixTTC=. then chg=.;
run;
data DureeSP95;
set DureeSP95;
by idpdv;
if first.idpdv then duree=1;
retain;
if chg=0 then duree=duree+1;
retain;
if chg=1 then duree=1;
retain;
run;
data DureeSP95;
set DureeSP95;
LagDuree=lag(Duree);
LagDate=lag(Date);
run;
data DureeSP95_MEF;
set DureeSP95;
if (chg=1 and NumJ=1 and LagDate=Date-2) 
or (chg=1 and NumJ in (2,3,4,5,6) and LagDate=Date-1);
rename Date=DateCgt 
NumJ=NumJLast;
keep idpdv Date LagDuree NumJ N00marque PrixTTC PrixHT;
run;
data DureeSP95_MEF;
set DureeSP95_MEF;
rename LagDuree=Duree;
run;
data petrole1.DureeSP95_MEF;
set DureeSP95_MEF;
Int=NumJLast-(Duree-6*int(Duree/6));
if NumJLast-(Duree-6*int(Duree/6))>0 then NumJ=NumJLast-(Duree-6*int(Duree/6));
else NumJ=NumJLast+6-(Duree-6*int(Duree/6));
drop Int;
run;







