/*data set to compute Figure B*/

/*merge our data set with market price " petrole1.Prixmarche" + compute the difference between 
price excluding taxes and Rotterdam price (market price)*/

/*Gazole*/
data PrixMarche;
set petrole1.Prixmarche;
keep Date GazoleRotterdam;
run;

proc sort data=petrole1.Etudefreqgaz_mef; by Date; run;
proc sort data=petrole1.PrixMarche; by Date; run;
data Etudefreqgaz_mef;
merge petrole1.Etudefreqgaz_mef (in=a) PrixMarche;
by Date; if a;
run;

proc sort data=Etudefreqgaz_mef; by idpdv date; run;

data Etudefreqgaz_mef;
set Etudefreqgaz_mef;
LagDate=lag(Date);
LagIdpdv=lag(idpdv);
LagPrixHT=lag(PrixHT);
if not(LagIdpdv=idpdv) 
or (not(LagDate=Date-1) and NumJ in (2,3,4,5,6)) 
or (not(LagDate=Date-2) and NumJ in (1)) then LagPrixHT=.;
Diff=100*(log(LagPrixHT)-log(GazoleRotterdam));
run;
data petrole1.TableBGaz;
set Etudefreqgaz_mef;
if not(evolDetail_MEF="N");
if evolDetail_MEF="+" then Hausse=1;
else Hausse=0;
if evolDetail_MEF="-" then Baisse=1;
else Baisse=0;
keep idpdv Date Diff Hausse Baisse;
run;

proc sql;
create table TableBGaz as
select *, mean(Diff) as MeanDiff from petrole1.TableBGaz group by idpdv; 
quit;
data petrole1.TableBGaz;
set TableBGaz;
if not(Diff=.);
DiffMEF=Diff-MeanDiff;
drop Diff MeanDiff;
run;

/*SP95*/
data PrixMarche;
set petrole1.Prixmarche;
keep Date EssenceRotterdam;
run;

proc sort data=petrole1.Etudefreqsp95_mef; by Date; run;
proc sort data=petrole1.PrixMarche; by Date; run;
data Etudefreqsp95_mef;
merge petrole1.Etudefreqsp95_mef (in=a) PrixMarche;
by Date; if a;
run;

proc sort data=Etudefreqsp95_mef; by idpdv date; run;

data Etudefreqsp95_mef;
set Etudefreqsp95_mef;
LagDate=lag(Date);
LagIdpdv=lag(idpdv);
LagPrixHT=lag(PrixHT);
if not(LagIdpdv=idpdv) 
or (not(LagDate=Date-1) and NumJ in (2,3,4,5,6)) 
or (not(LagDate=Date-2) and NumJ in (1)) then LagPrixHT=.;
Diff=100*(log(LagPrixHT)-log(EssenceRotterdam));
run;
data petrole1.TableBsp95;
set Etudefreqsp95_mef;
if not(evolDetail_MEF="N");
if evolDetail_MEF="+" then Hausse=1;
else Hausse=0;
if evolDetail_MEF="-" then Baisse=1;
else Baisse=0;
keep idpdv Date Diff Hausse Baisse;
run;

proc sql;
create table TableBsp95 as
select *, mean(Diff) as MeanDiff from petrole1.TableBsp95 group by idpdv; 
quit;
data petrole1.TableBsp95;
set TableBsp95;
if not(Diff=.);
DiffMEF=Diff-MeanDiff;
drop Diff MeanDiff;
run;


proc univariate data=petrole1.TableBsp95;
histogram DiffMEF;
run;

