/*
calculate average frequency of price changes, increases and decreases by gas station + average size of price increases and decreases by gas stations (correcting size of rpice change by beta)*/


/*initial data set (restricted to our sample, gas stations with more than 300 observations*/
/*evolDetail_MEF variable indicating whether tthere is a price change, increase or decrease*/


/*Frquence*/
/*Gazole*/
data etudeFreqGaz;
set petrole1.Etudefreqgaz_mef;
if not(evolDetail_MEF="N");
run;
/*on commence par crer une table avec les frquence par stations services*/
proc freq data=etudeFreqGaz noprint;
tables evolDetail_MEF / out=FreqGazStation; 
by idpdv;
run;
data TotalFreqGaz;
set FreqGazStation; 
if evolDetail_MEF="0";
PERCENT=100-PERCENT;
rename PERCENT=Total;
drop evolDetail_MEF COUNT;
run;
data IncFreqGaz;
set FreqGazStation; 
if evolDetail_MEF="+";
rename PERCENT=Inc;
drop evolDetail_MEF COUNT;
run;
data DecFreqGaz;
set FreqGazStation; 
if evolDetail_MEF="-";
rename PERCENT=Dec;
drop evolDetail_MEF COUNT;
run;
proc sort data=TotalFreqGaz; by idpdv; run;
proc sort data=IncFreqGaz; by idpdv; run;
proc sort data=DecFreqGaz; by idpdv; run;
data FreqGaz;
merge TotalFreqGaz IncFreqGaz DecFreqGaz;
by idpdv; run;
data FreqGaz;
set FreqGaz;
if total=. then total=0;
if inc=. then inc=0;
if dec=. then dec=0;
run;
data FreqGaz;
set FreqGaz;
ImpliedDuration=100/total;
run;
data FreqGaz;
set FreqGaz;
label total='FreqTotalGaz' 
inc='FreqHausseGaz' 
dec='FreqBaisseGaz' 
ImpliedDuration='DureeGaz';
rename total=FreqTotalGaz 
inc=freqhaussegaz 
dec=freqbaissegaz 
ImpliedDuration=DureeGaz;
run; 



/*UNLEADED PETROL SP 95*/
data etudeFreqSP95;
set petrole1.EtudefreqSP95_mef;
if not(evolDetail_MEF="N");
run;
proc freq data=etudeFreqSP95 noprint;
tables evolDetail_MEF / out=FreqSP95Station; 
by idpdv;
run;
data TotalFreqSP95;
set FreqSP95Station; 
if evolDetail_MEF="0";
PERCENT=100-PERCENT;
rename PERCENT=Total;
drop evolDetail_MEF COUNT;
run;
data IncFreqSP95;
set FreqSP95Station; 
if evolDetail_MEF="+";
rename PERCENT=Inc;
drop evolDetail_MEF COUNT;
run;
data DecFreqSP95;
set FreqSP95Station; 
if evolDetail_MEF="-";
rename PERCENT=Dec;
drop evolDetail_MEF COUNT;
run;
proc sort data=TotalFreqSP95; by idpdv; run;
proc sort data=IncFreqSP95; by idpdv; run;
proc sort data=DecFreqSP95; by idpdv; run;
data FreqSP95;
merge TotalFreqSP95 IncFreqSP95 DecFreqSP95;
by idpdv; run;
data FreqSP95;
set FreqSP95;
if total=. then total=0;
if inc=. then inc=0;
if dec=. then dec=0;
run;
data FreqSP95;
set FreqSP95;
ImpliedDuration=100/total;
run;
data FreqSP95;
set FreqSP95;
label total='FreqTotalSP95' 
inc='FreqHausseSP95' 
dec='FreqBaisseSP95' 
ImpliedDuration='DureeSP95';
rename total=FreqTotalSP95  
inc=freqhausseSP95 
dec=freqbaisseSP95 
ImpliedDuration=DureeSP95;
run; 



/*initial data set consists of all price changes (corrected by beta at the gas station level)*/
/*Intensity size of price change*/
/*Gazole*/
proc means data=petrole1.Intensitegaz_mef noprint;
class idpdv;
where DprixTTC_MEF>0;
var DprixTTC_MEF;
output out=MeanDprixTTCHausse mean=TailleTTCHausseGaz;
run;
data MeanDprixTTCHausse;
set MeanDprixTTCHausse;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.Intensitegaz_mef noprint;
class idpdv;
where DprixTTC_MEF>0;
var DprixTTC_beta_MEF;
output out=MeanDprixTTCHausse_beta mean=TailleTTCHausseGaz_beta;
run;
data MeanDprixTTCHausse_beta;
set MeanDprixTTCHausse_beta;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.Intensitegaz_mef noprint;
class idpdv;
where DprixTTC_MEF<0;
var DprixTTC_MEF;
output out=MeanDprixTTCBaisse mean=TailleTTCBaisseGaz;
run;
data MeanDprixTTCBaisse;
set MeanDprixTTCBaisse;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.Intensitegaz_mef noprint;
class idpdv;
where DprixTTC_MEF<0;
var DprixTTC_beta_MEF;
output out=MeanDprixTTCBaisse_beta mean=TailleTTCBaisseGaz_beta;
run;
data MeanDprixTTCBaisse_beta;
set MeanDprixTTCBaisse_beta;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.Intensitegaz_mef noprint;
class idpdv;
where DprixHT_MEF>0;
var DprixHT_MEF;
output out=MeanDprixHTHausse mean=TailleHTHausseGaz;
run;
data MeanDprixHTHausse;
set MeanDprixHTHausse;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.Intensitegaz_mef noprint;
class idpdv;
where DprixHT_MEF>0;
var DprixHT_beta_MEF;
output out=MeanDprixHTHausse_beta mean=TailleHTHausseGaz_beta;
run;
data MeanDprixHTHausse_beta;
set MeanDprixHTHausse_beta;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.Intensitegaz_mef noprint;
class idpdv;
where DprixHT_MEF<0;
var DprixHT_MEF;
output out=MeanDprixHTBaisse mean=TailleHTBaisseGaz;
run;
data MeanDprixHTBaisse;
set MeanDprixHTBaisse;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.Intensitegaz_mef noprint;
class idpdv;
where DprixHT_MEF<0;
var DprixHT_beta_MEF;
output out=MeanDprixHTBaisse_beta mean=TailleHTBaisseGaz_beta;
run;
data MeanDprixHTBaisse_beta;
set MeanDprixHTBaisse_beta;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;

proc sort data=MeanDprixTTCHausse; by idpdv; run;
proc sort data=MeanDprixTTCHausse_beta; by idpdv; run;
proc sort data=MeanDprixTTCBaisse; by idpdv; run;
proc sort data=MeanDprixTTCBaisse_beta; by idpdv; run;
proc sort data=MeanDprixHTHausse; by idpdv; run;
proc sort data=MeanDprixHTHausse_beta; by idpdv; run;
proc sort data=MeanDprixHTBaisse; by idpdv; run;
proc sort data=MeanDprixHTBaisse_beta; by idpdv; run;
data TailleGaz;
merge MeanDprixTTCHausse MeanDprixTTCHausse_beta MeanDprixTTCBaisse MeanDprixTTCBaisse_beta
MeanDprixHTHausse MeanDprixHTHausse_beta MeanDprixHTBaisse MeanDprixHTBaisse_beta;
by idpdv; run;

/*UNLEADED PETROL*/
proc means data=petrole1.IntensiteSP95_mef noprint;
class idpdv;
where DprixTTC_MEF>0;
var DprixTTC_MEF;
output out=MeanDprixTTCHausse mean=TailleTTCHausseSP95;
run;
data MeanDprixTTCHausse;
set MeanDprixTTCHausse;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.IntensiteSP95_mef noprint;
class idpdv;
where DprixTTC_MEF>0;
var DprixTTC_beta_MEF;
output out=MeanDprixTTCHausse_beta mean=TailleTTCHausseSP95_beta;
run;
data MeanDprixTTCHausse_beta;
set MeanDprixTTCHausse_beta;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.IntensiteSP95_mef noprint;
class idpdv;
where DprixTTC_MEF<0;
var DprixTTC_MEF;
output out=MeanDprixTTCBaisse mean=TailleTTCBaisseSP95;
run;
data MeanDprixTTCBaisse;
set MeanDprixTTCBaisse;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.IntensiteSP95_mef noprint;
class idpdv;
where DprixTTC_MEF<0;
var DprixTTC_beta_MEF;
output out=MeanDprixTTCBaisse_beta mean=TailleTTCBaisseSP95_beta;
run;
data MeanDprixTTCBaisse_beta;
set MeanDprixTTCBaisse_beta;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.IntensiteSP95_mef noprint;
class idpdv;
where DprixHT_MEF>0;
var DprixHT_MEF;
output out=MeanDprixHTHausse mean=TailleHTHausseSP95;
run;
data MeanDprixHTHausse;
set MeanDprixHTHausse;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.IntensiteSP95_mef noprint;
class idpdv;
where DprixHT_MEF>0;
var DprixHT_beta_MEF;
output out=MeanDprixHTHausse_beta mean=TailleHTHausseSP95_beta;
run;
data MeanDprixHTHausse_beta;
set MeanDprixHTHausse_beta;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.IntensiteSP95_mef noprint;
class idpdv;
where DprixHT_MEF<0;
var DprixHT_MEF;
output out=MeanDprixHTBaisse mean=TailleHTBaisseSP95;
run;
data MeanDprixHTBaisse;
set MeanDprixHTBaisse;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;
proc means data=petrole1.IntensiteSP95_mef noprint;
class idpdv;
where DprixHT_MEF<0;
var DprixHT_beta_MEF;
output out=MeanDprixHTBaisse_beta mean=TailleHTBaisseSP95_beta;
run;
data MeanDprixHTBaisse_beta;
set MeanDprixHTBaisse_beta;
if _TYPE_=1;
drop _TYPE_ _FREQ_;
run;

proc sort data=MeanDprixTTCHausse; by idpdv; run;
proc sort data=MeanDprixTTCHausse_beta; by idpdv; run;
proc sort data=MeanDprixTTCBaisse; by idpdv; run;
proc sort data=MeanDprixTTCBaisse_beta; by idpdv; run;
proc sort data=MeanDprixHTHausse; by idpdv; run;
proc sort data=MeanDprixHTHausse_beta; by idpdv; run;
proc sort data=MeanDprixHTBaisse; by idpdv; run;
proc sort data=MeanDprixHTBaisse_beta; by idpdv; run;
data TailleSP95;
merge MeanDprixTTCHausse MeanDprixTTCHausse_beta MeanDprixTTCBaisse MeanDprixTTCBaisse_beta
MeanDprixHTHausse MeanDprixHTHausse_beta MeanDprixHTBaisse MeanDprixHTBaisse_beta;
by idpdv; run;

/*Base Totale*/
proc sql;
create table marqueGaz as 
select distinct idpdv, N00marque from petrole1.Etudefreqgaz_mef;
create table marqueSP95 as 
select distinct idpdv, N00marque as N00marqueSP from petrole1.EtudefreqSP95_mef;
quit;
proc sort data=marqueGaz; by idpdv; run;
proc sort data=marqueSP95; by idpdv; run;
data marque;
merge marqueGaz marqueSP95;
by idpdv; run;
data errsMarque;
set marque;
if not(N00marque=N00marqueSP);
run;
data marque;
set marque;
if N00marque="" then N00marque=N00marqueSP;
run; 
proc sort data=marque; by idpdv; run;
proc sort data=Freqgaz; by idpdv; run;
proc sort data=Freqsp95; by idpdv; run;
proc sort data=TailleGaz; by idpdv; run;
proc sort data=TailleSP95; by idpdv; run;
data petrole1.MoyenneStations;
merge marque Freqgaz Freqsp95 TailleGaz TailleSP95;
by idpdv;
run;
data petrole1.MoyenneStations;
set petrole1.MoyenneStations;
drop N00marqueSP;
run;
 
proc freq data=petrole1.MoyenneStations;
tables N00marque;
run; 
