/*initial data set containing durations since the last price adjustment for all gas stations*/
/*censored trajectories were deleted*/

data Dureegazole;
set petrole1.Dureegaz_mef;
day=numj;
keep Duree day N00Marque;
run;

data Dureesp95;
set petrole1.Dureesp95_mef;
day=numj;
keep Duree day N00Marque;
run;


/*********************/
/*  Figure 1 : PROC LIFETEST */
/*********************/

/*diesel*/

/*ALL*/
proc lifetest data=Dureegazole plots=(h s p) outsurv=tab_hsd_GAZOLE 
intervals=(1 to 25 by 1) method =act maxtime=25 noprint;
time Duree;
run;
data hasard; set tab_hsd_GAZOLE; if duree = 0 then delete; drop midpoint; keep duree hazard; run;

/*Supermarkets*/
data Dureegazole_super;
set Dureegazole;
if N00Marque="1";
run;
proc lifetest data=Dureegazole_super plots=(h s p) outsurv=tab_hsd_GAZOLE 
intervals=(1 to 25 by 1) method =act maxtime=25 noprint;
time Duree;
run;
data hasard_super; set tab_hsd_GAZOLE; if duree = 0 then delete; drop midpoint; rename hazard=hazard_super; keep duree hazard; run;

/*Others*/
data Dureegazole_others;
set Dureegazole;
if N00Marque="0";
run;
proc lifetest data=Dureegazole_others plots=(h s p) outsurv=tab_hsd_GAZOLE 
intervals=(1 to 25 by 1) method =act maxtime=25 noprint;
time Duree;
run;

data hasard_others; set tab_hsd_GAZOLE; if duree = 0 then delete; drop midpoint; rename hazard=hazard_others; keep duree hazard; run;



/*unleaded petrol*/


proc lifetest data=Dureesp95 plots=(h s p) outsurv=tab_hsd_SP 
intervals=(1 to 25 by 1) method =act maxtime=25 noprint;
time Duree;
run;
data hasard; set tab_hsd_SP; if duree = 0 then delete; drop midpoint; keep duree hazard; run;

/*Supermarkets*/
data Dureesp95_super;
set Dureesp95;
if N00Marque="1";
run;
proc lifetest data=Dureesp95_super plots=(h s p) outsurv=tab_hsd_GAZOLE 
intervals=(1 to 25 by 1) method =act maxtime=25 noprint;
time Duree;
run;
data hasard_super; set tab_hsd_GAZOLE; if duree = 0 then delete; drop midpoint; rename hazard=hazard_super; keep duree hazard; run;

/*Others*/
data Dureesp95_others;
set Dureesp95;
if N00Marque="0";
run;
proc lifetest data=Dureesp95_others plots=(h s p) outsurv=tab_hsd_GAZOLE 
intervals=(1 to 25 by 1) method =act maxtime=25 noprint;
time Duree;
run;
data hasard_others; set tab_hsd_GAZOLE; if duree = 0 then delete; drop midpoint; rename hazard=hazard_others; keep duree hazard; run;
