clear
clear matrix

set memory 500m,

/*load data set including value of paramters estimates from our baseline model + individual characteristics of gas stations*/

insheet using "***.txt", clear tab,

drop if s_s_mean >25
drop if s_s_mean <-25


/*generate dummy variables for population categories (p08_pop is the population; numdep the number for departement (75 92 93 94 region around Paris))*/

gen ZoneRurale =(p08_pop<20000)*(numdep!="75")*(numdep!="92")*(numdep!="93")*(numdep!="94")
gen PetiteVille =(p08_pop>=20000)*(p08_pop<100000)*(numdep!="75")*(numdep!="92")*(numdep!="93")*(numdep!="94")
gen GrandeVille =(p08_pop>=100000)*(numdep!="75")*(numdep!="92")*(numdep!="93")*(numdep!="94")
gen Paris =(numdep=="75")|(numdep=="92")|(numdep=="93")|(numdep=="94")
gen Ville=PetiteVille+GrandeVille

/*boutique = 1 if there is a shop*/
gen boutique=0
replace boutique=1 if boutique_alim==1
replace boutique=1 if boutique_non_alim==1

/*servicesauto=1 if there are some services in the gas station*/
gen servicesauto=0
replace servicesauto=1 if lavage_multi==1
replace servicesauto=1 if lavage==1
replace servicesauto=1 if gonflage==1
replace servicesauto=1 if bais_servs==1
replace servicesauto=1 if location_vehic==1

gen vente_gazfioul=0
replace vente_gazfioul=1 if vente_fioul==1
replace vente_gazfioul=1 if  vente_gaz==1

/**rest=1 if there is a restaurant*/
gen rest=0
replace rest=1 if rest_surpl==1
replace rest=1 if rest_emporter==1

  
*Estimation alpha
*distminsuper: distance to the next supermarket
*ninf10allsuper: number of supermarkets
*ipricingpoints; pricing point dummy
*pct2voiture: % of car users
*txchom2564: unemployment rate
*automate_cb: credit card automatic payment
*carb_qual: high quality gasoline
*i.n3marque i.numreg controls for trade mark of gasoline stations and controls for regions


est store alpha_reg
xi : reg  alpha /*beta */ distminsuper ninf10allsuper  autoroute ipricingpoints  pct2voiture PetiteVille GrandeVille Paris txchom2564 automate_cb boutique rest servicesauto carb_qual vente_gazfioul i.n3marque i.numreg 
est store alpha_reg
cd "***"



*Estimation pour Beta
xi : reg  beta /*alpha*/ distminsuper ninf10allsuper autoroute ipricingpoints  pct2voiture PetiteVille GrandeVille Paris txchom2564 automate_cb boutique rest servicesauto carb_qual vente_gazfioul i.n3marque i.numreg 
est store beta_reg
*Estimation pour les bornes s
xi : reg  s_s_mean distminsuper ninf10allsuper autoroute ipricingpoints  pct2voiture PetiteVille GrandeVille Paris txchom2564 automate_cb boutique rest servicesauto carb_qual vente_gazfioul i.n3marque i.numreg 

est store s_s_mean_reg
	outreg2  [alpha_reg beta_reg s_s_mean] using diesel_duration, excel replace drop(_Inumreg* _In3marq*) label bdec(3) addstat(R-Sq, e(r2_o)) title(Table) 
