/*Table 1*/


/*formats*/
proc format;

value $marque 
      '1' = 'Supermarchs'
	  '0' = 'Autres distributeurs';

run;

/*Cration des labels*/
data tableEtude;
set petrole1.MoyenneStations ;
label DureeGaz="Diesel - Dure moyenne (en jours)"
FreqTotalGaz="Diesel - Frquence (en %) Changements" 
freqhaussegaz="Diesel - Frquence (en %) Hausses" 
freqbaissegaz="Diesel - Frquence (en %) Baisses"  
DureeSP95="SP 95 - Dure moyenne (en jours)"  
freqTotalSP95="SP 95 - Frquence (en %) Changements" 
freqhaussesp95="SP 95 - Frquence (en %) Hausses" 
freqbaissesp95="SP 95 - Frquence (en %) Baisses" 
TailleTTCHausseGaz="Diesel - Taille (en %) Hausses TTC" 
TailleTTCHausseGaz_beta="Diesel - Taille (en %, Beta) Hausses TTC" 
TailleTTCBaisseGaz="Diesel - Taille (en %) Baisses TTC" 
TailleTTCBaisseGaz_beta="Diesel - Taille (en %, Beta) Baisses TTC" 
TailleHTHausseGaz="Diesel - Taille (en %) Hausses HT" 
TailleHTHausseGaz_beta="Diesel - Taille (en %, Beta) Hausses HT" 
TailleHTBaisseGaz="Diesel - Taille (en %) Baisses HT" 
TailleHTBaisseGaz_beta="Diesel - Taille (en %, Beta) Baisses HT"
TailleTTCHausseSP95="SP 95 - Taille (en %) Hausses TTC" 
TailleTTCHausseSP95_beta="SP 95 - Taille (en %, Beta) Hausses TTC" 
TailleTTCBaisseSP95="SP 95 - Taille (en %) Baisses TTC" 
TailleTTCBaisseSP95_beta="SP 95 - Taille (en %, Beta) Baisses TTC" 
TailleHTHausseSP95="SP 95 - Taille (en %) Hausses HT" 
TailleHTHausseSP95_beta="SP 95 - Taille (en %, Beta) Hausses HT" 
TailleHTBaisseSP95="SP 95 - Taille (en %) Baisses HT" 
TailleHTBaisseSP95_beta="SP 95 - Taille (en %, Beta) Baisses HT"
N00marque="marque";
run;


Ods html body="***\Tableau1.html" style=sasweb;

proc sort data=tableEtude ;
by descending N00marque;
run;

proc tabulate data=tableEtude order=data;
format N00marque $marque. ;
class N00marque;
table (DureeGaz FreqTotalGaz freqhaussegaz freqbaissegaz TailleHTHausseGaz_beta TailleHTBaisseGaz_beta TailleHTHausseGaz TailleHTBaisseGaz 
DureeSP95 freqTotalSP95 freqhaussesp95 freqbaissesp95 TailleHTHausseSP95_beta TailleHTBaisseSP95_beta TailleHTHausseSP95 TailleHTBaisseSP95),(all N00marque)*(n mean);
var DureeGaz FreqTotalGaz freqhaussegaz freqbaissegaz TailleHTHausseGaz_beta TailleHTBaisseGaz_beta TailleHTHausseGaz TailleHTBaisseGaz
DureeSP95 freqTotalSP95 freqhaussesp95 freqbaissesp95 TailleHTHausseSP95_beta TailleHTBaisseSP95_beta TailleHTHausseSP95 TailleHTBaisseSP95;
run;

Ods html close;



/*Statistiques coomplmentaires*/
proc sql;
create table Ngaz as 
select distinct idpdv, count(*) as Ngaz from petrole1.Etudefreqgaz_mef group by idpdv;
create table NHaussegaz as 
select distinct idpdv, count(*) as NHaussegaz from petrole1.Etudefreqgaz_mef where evolDetail_MEF="+" group by idpdv;
create table NBaissegaz as 
select distinct idpdv, count(*) as NBaissegaz from petrole1.Etudefreqgaz_mef where evolDetail_MEF="-" group by idpdv;
create table Nsp95 as 
select distinct idpdv, count(*) as Nsp95 from petrole1.Etudefreqsp95_mef group by idpdv;
create table NHaussesp95 as 
select distinct idpdv, count(*) as NHaussesp95 from petrole1.Etudefreqsp95_mef where evolDetail_MEF="+" group by idpdv;
create table NBaissesp95 as 
select distinct idpdv, count(*) as NBaissesp95 from petrole1.Etudefreqsp95_mef where evolDetail_MEF="-" group by idpdv;
quit;
proc sort data=Ngaz; by idpdv; run;
proc sort data=NHaussegaz; by idpdv; run;
proc sort data=NBaissegaz; by idpdv; run;
proc sort data=Nsp95; by idpdv; run;
proc sort data=NHaussesp95; by idpdv; run;
proc sort data=NBaissesp95; by idpdv; run;
data Nobs;
merge Ngaz NHaussegaz NBaissegaz Nsp95 NHaussesp95 NBaissesp95;
by idpdv; 
run;
Ods html body="***\Tableau1.html" style=sasweb;
proc means data=Nobs n mean median min max;
var Ngaz NHaussegaz NBaissegaz Nsp95 NHaussesp95 NBaissesp95;
run;
Ods html close;
