/*TABLE A*/
/********************************************************************************/
/*Psychological prices */
/********************************************************************************/

/*Diesel*/
data DernierchiffreGaz;
set Gazolettc;
/*last digit*/
Dchiffre=int(1000*(prixTTC-int(prixTTC)-0.1*int(10*(prixTTC-int(prixTTC)))-0.01*int(100*(prixTTC-int(prixTTC)-0.1*int(10*(prixTTC-int(prixTTC)))))));
/*second digit*/
ADchiffre=int(100*(prixTTC-int(prixTTC)-0.1*int(10*(prixTTC-int(prixTTC)))));
run;

/*Distribution of the last digit*/
proc tabulate data=DernierchiffreGaz ;
class Dchiffre ;
table (pctn), Dchiffre ;
ods output table=Tab4GazDistri;
run ;
data Tab4GazDistrimef;
set Tab4GazDistri;
rename PctN_0=Distri_Gaz Dchiffre=chiffre ;
drop _TYPE_ _PAGE_ _TABLE_ ;
run;

/*Distribution of the second digit*/
proc tabulate data=DernierchiffreGaz ;
class ADchiffre ;
table (pctn), ADchiffre ;
ods output table=Tab4GazDistriAD;
run ;
data Tab4GazDistriADmef;
set Tab4GazDistriAD;
rename PctN_0=DistriAD_Gaz ADchiffre=chiffre ;
drop _TYPE_ _PAGE_ _TABLE_ ;
run;

/*average duration distribution by digit*/
proc tabulate data=DernierchiffreGaz ;
class Dchiffre ;
table (mean), duree*Dchiffre ;
var duree;
ods output table=Tab4GazDuree;
run ;
data Tab4GazDureemef;
set Tab4GazDuree;
rename Duree_mean=Duree_Gaz Dchiffre=chiffre ;
drop _TYPE_ _PAGE_ _TABLE_ ;
run;

/*Unleaded petrol*/
data DernierchiffreSP;
set Sp95ttc;
Dchiffre=int(1000*(prixTTC-int(prixTTC)-0.1*int(10*(prixTTC-int(prixTTC)))-0.01*int(100*(prixTTC-int(prixTTC)-0.1*int(10*(prixTTC-int(prixTTC)))))));
ADchiffre=int(100*(prixTTC-int(prixTTC)-0.1*int(10*(prixTTC-int(prixTTC)))));
run;

/*Distribution of the last digit*/
proc tabulate data=DernierchiffreSP ;
class Dchiffre ;
table (pctn), Dchiffre ;
ods output table=Tab4SPDistri;
run ;
data Tab4SPDistrimef;
set Tab4SPDistri;
rename PctN_0=Distri_SP Dchiffre=chiffre;
drop _TYPE_ _PAGE_ _TABLE_ ;
run;

/*Distribution of the second digit*/
proc tabulate data=DernierchiffreSP ;
class ADchiffre ;
table (pctn), ADchiffre ;
ods output table=Tab4SPDistriAD;
run ;
data Tab4SPDistriADmef;
set Tab4SPDistriAD;
rename PctN_0=DistriAD_SP ADchiffre=chiffre ;
drop _TYPE_ _PAGE_ _TABLE_ ;
run;

/*average duration distribution by digit*/
proc tabulate data=DernierchiffreSP ;
class Dchiffre ;
table (mean), duree*Dchiffre ;
var duree;
ods output table=Tab4SPDuree;
run ;
data Tab4SPDureemef;
set Tab4SPDuree;
rename Duree_mean=Duree_SP Dchiffre=chiffre;
drop _TYPE_ _PAGE_ _TABLE_ ;
run;

/*Table A*/
proc sort data=Tab4GazDistrimef ; by chiffre; run;
proc sort data=Tab4GazDistriADmef ; by chiffre; run;
proc sort data=Tab4GazDureemef ; by chiffre; run;
proc sort data=Tab4SPDistrimef ; by chiffre; run;
proc sort data=Tab4SPDistriADmef ; by chiffre; run;
proc sort data=Tab4SPDureemef ; by chiffre; run;
data Tab5;
merge Tab4GazDistrimef Tab4GazDureemef Tab4SPDistrimef Tab4SPDureemef 
Tab4GazDistriADmef Tab4SPDistriADmef ;
by chiffre;
run;
