/*construct Figure B*/
/********************************************************************************/
/*price changes and difference between observed and optimal price */
/********************************************************************************/

/*diesel*/
proc rank data=petrole1.Tablebgaz groups=1000 out=int; 
ranks rang1000;
var DiffMEF;
run;

proc means data=int noprint;
class rang1000;
var Hausse;
output out=Hausse mean=TxHausse;
run;
data Hausse;
set Hausse;
if _type_=1;
drop _type_ _freq_;
run;
proc means data=int noprint;
class rang1000;
var Baisse;
output out=Baisse mean=TxBaisse;
run;
data Baisse;
set Baisse;
if _type_=1;
drop _type_ _freq_;
run;
proc means data=int noprint;
class rang1000;
var DiffMEF;
output out=Diff mean=DiffMean median=DiffMedian;
run;
data Diff;
set Diff;
if _type_=1;
drop _type_ _freq_;
run;

proc sort data=Hausse; by rang1000; run;
proc sort data=Baisse; by rang1000; run;
proc sort data=Diff; by rang1000; run;
data etudeGaz;
merge Hausse Baisse Diff;
by rang1000;
run;

proc gplot data=etudeGaz;
plot (TxHausse TxBaisse)*DiffMean;
run;
quit;

/*sp 95*/
proc rank data=petrole1.Tablebsp95 groups=1000 out=int; 
ranks rang1000;
var DiffMEF;
run;

proc means data=int noprint;
class rang1000;
var Hausse;
output out=Hausse mean=TxHausse;
run;
data Hausse;
set Hausse;
if _type_=1;
drop _type_ _freq_;
run;
proc means data=int noprint;
class rang1000;
var Baisse;
output out=Baisse mean=TxBaisse;
run;
data Baisse;
set Baisse;
if _type_=1;
drop _type_ _freq_;
run;
proc means data=int noprint;
class rang1000;
var DiffMEF;
output out=Diff mean=DiffMean median=DiffMedian;
run;
data Diff;
set Diff;
if _type_=1;
drop _type_ _freq_;
run;

proc sort data=Hausse; by rang1000; run;
proc sort data=Baisse; by rang1000; run;
proc sort data=Diff; by rang1000; run;
data etudeSP95;
merge Hausse Baisse Diff;
by rang1000;
run;

proc gplot data=etudeSP95;
plot (TxHausse TxBaisse)*DiffMean;
run;
quit;

/*Variantes*/
/*%kernel_smooth(data_ks=petrole1.Tablebgaz, h_ks =0.02, nb_points_ks =1000,
var_ks =DiffMEF, var_mean_ks =Hausse,min_ks =-10,max_ks =10);*/

